(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2004 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY Admap5;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    OddParityEnabled);

CONST
  ToolCount = 26;
  Both = [UsageDraw, UsageFlash];
  ToolTable: array [1..ToolCount] of ToolDescr_T = (
    (DescrStr: '73: Octagon .25 mm'; Shape: CircleTool;  Width:  250; Height: 0; Usage: Both; Code: 73),
    (DescrStr: '74: Octagon 0.3 mm'; Shape: CircleTool;  Width:  300; Height: 0; Usage: Both; Code: 74),
    (DescrStr: '75: Octagon 0.4 mm'; Shape: CircleTool;  Width:  400; Height: 0; Usage: Both; Code: 75),
    (DescrStr: '76: Octagon 0.5 mm'; Shape: CircleTool;  Width:  500; Height: 0; Usage: Both; Code: 76),
    (DescrStr: '77: Octagon 0.7 mm'; Shape: CircleTool;  Width:  700; Height: 0; Usage: Both; Code: 77),
    (DescrStr: '78: Octagon 1.0 mm'; Shape: CircleTool;  Width: 1000; Height: 0; Usage: Both; Code: 78),
    (DescrStr: '79: Octagon 1.3 mm'; Shape: CircleTool;  Width: 1300; Height: 0; Usage: Both; Code: 79),
    (DescrStr: '80: Octagon 1.5 mm'; Shape: CircleTool;  Width: 1500; Height: 0; Usage: Both; Code: 80),
    (DescrStr: '81: Octagon 1.8 mm'; Shape: CircleTool;  Width: 1800; Height: 0; Usage: Both; Code: 81),
    (DescrStr: '82: Octagon 2.0 mm'; Shape: CircleTool;  Width: 2000; Height: 0; Usage: Both; Code: 82),
    (DescrStr: '83: Octagon 2.5 mm'; Shape: CircleTool;  Width: 2500; Height: 0; Usage: Both; Code: 83),
    (DescrStr: '84: Octagon 3.0 mm'; Shape: CircleTool;  Width: 3000; Height: 0; Usage: Both; Code: 84),
    (DescrStr: '85: Octagon 3.5 mm'; Shape: CircleTool;  Width: 3500; Height: 0; Usage: Both; Code: 85),
    (DescrStr: '86: Octagon 4.0 mm'; Shape: CircleTool;  Width: 4000; Height: 0; Usage: Both; Code: 86),
    (DescrStr: '87: Circle  1.6 mm'; Shape: SpecialTool; Width: 1600; Height: 0; Usage: Both; Code: 87),
    (DescrStr: '88: Circle  1.9 mm'; Shape: SpecialTool; Width: 1900; Height: 0; Usage: Both; Code: 88),
    (DescrStr: '89: Circle  2.4 mm'; Shape: SpecialTool; Width: 2400; Height: 0; Usage: Both; Code: 89),
    (DescrStr: '90: Square  1.6 mm'; Shape: SpecialTool; Width: 1600; Height: 0; Usage: Both; Code: 90),
    (DescrStr: '91: Square  1.9 mm'; Shape: SpecialTool; Width: 1900; Height: 0; Usage: Both; Code: 91),
    (DescrStr: '92: Square  2.4 mm'; Shape: SpecialTool; Width: 2400; Height: 0; Usage: Both; Code: 92),
    (DescrStr: '93:  1.6 by 2.6 mm'; Shape: SpecialTool; Width: 2600; Height: 0; Usage: Both; Code: 93),
    (DescrStr: '94:  2.6 by 1.6 mm'; Shape: SpecialTool; Width: 2600; Height: 0; Usage: Both; Code: 94),
    (DescrStr: '95:  1.3 by 2.5 mm'; Shape: SpecialTool; Width: 2500; Height: 0; Usage: Both; Code: 95),
    (DescrStr: '96:  2.5 by 1.3 mm'; Shape: SpecialTool; Width: 2500; Height: 0; Usage: Both; Code: 96),
    (DescrStr: '99: Cross   2.5 mm'; Shape: SpecialTool; Width: 2500; Height: 0; Usage: Both; Code: 99),
    (DescrStr: ' 0: Wheel   4.0 mm'; Shape: SpecialTool; Width: 4000; Height: 0; Usage: Both; Code:  0));

  DriverDescr: DriverDescr_T = (
    Name:         'Admap 5   PH 1995';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [Optimizable, DrawLines, FlashPads];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'Admap5';
    TargetExt:    '';
    NoOfTools:    ToolCount;
    InitialTools: @ ToolTable [1];
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           0;
    Y0:           0;
    X1:           350;
    Y1:           250;
    XDividend:    4;
    YDividend:    4;
    Divisor:      1);

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr:  '>Odd Parity';
    Value:     Ord (false);
    ParamType: _Explicite;
    Values:    'Off|On'));

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// -----------------------------------------------------------------------------

VAR
  CurrentX, CurrentY: DriverUnits_T;
  CurrentToolNumber: integer;

  LineInProgress: Boolean;
  VerticesInLine: integer;

CONST
  VerticesPerLine = 5;
  OneNewLine  = ^M^J;
  TwoNewLines = ^M^J^M^J;

procedure Output (AsciiString: string);
  var i: integer;
begin
  if Boolean (Params [OddParityEnabled].Value) then
    for i := 1 to Length (AsciiString) do
      AsciiString [i] := OddParity (AsciiString [i]);
  Write (AsciiString [1], Length (AsciiString));
end;

procedure OutputCoordinates (EquipmentX, EquipmentY: DriverUnits_T);
begin
  Output (IntStr (EquipmentX div 10));
  if EquipmentX mod 10 <> 0 then
    Output ('.' + IntStr (EquipmentX mod 10));
  Output (',' + IntStr (EquipmentY div 10));
  if EquipmentY mod 10 <> 0 then
    Output ('.' + IntStr (EquipmentY mod 10));
  Output (',');
end;

procedure BreakLine;
begin
  if LineInProgress then begin
    if VerticesInLine > 0 then
      Output (TwoNewLines)
    else
      Output (OneNewLine);
    LineInProgress := false;
    VerticesInLine := 0;
  end;
end;

// -----------------------------------------------------------------------------

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;

  LineInProgress := false;
  VerticesInLine := 0;
  CurrentX := -MaxInt;   CurrentY := -MaxInt;
  CurrentToolNumber := -1;

  Output ('ADMAP 4/5 DATA FORMAT' + TwoNewLines);   (* ??? *)

  Output (':');
  OutputCoordinates (X1, Y1);
  Output (TwoNewLines);
end;

PROCEDURE Comment (const CommentString: string);   (* ??? *)
begin
end;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
end;

procedure ChangeLineAperture (ToolNumber: integer);
  var LineWidth: string [3];
begin
  Str (WorkToolTable [ToolNumber].Width / 1000: 3: 1, LineWidth);
  Output ('L:' + LineWidth + ',' + TwoNewLines);
  CurrentToolNumber := ToolNumber;
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  if ((ToolNumber <> CurrentToolNumber)
    or (X0 <> CurrentX) or (Y0 <> CurrentY))
  then
    BreakLine;

  if ToolNumber <> CurrentToolNumber then
    ChangeLineAperture (ToolNumber);

  if not LineInProgress then begin
    Output ('T:');
    OutputCoordinates (X0, Y0);
    Inc (VerticesInLine);
  end;

  Output ('T:');
  OutputCoordinates (X1, Y1);
  Inc (VerticesInLine);
  if VerticesInLine > VerticesPerLine then begin
    Output (OneNewLine);
    VerticesInLine := 0
  end;

  LineInProgress := true;
  CurrentX := X1;   CurrentY := Y1;
end;

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  BreakLine;
  Output (IntStr (WorkToolTable [ToolNumber].Code) + ':');
  OutputCoordinates (X, Y);
  Output (TwoNewLines);

  LineInProgress := false;
  VerticesInLine := 0;
end;

PROCEDURE CloseEquip;
begin
  BreakLine;
  Output ('V' + TwoNewLines);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  FlashPad,
  CloseEquip;

BEGIN
END.
