(* -----------------------------------------------------------------------------

   =====================================

    FORMICA 4.40 LAYOUT
    Copyright (C) 1986-2004 Petr Horsk

   =====================================


--- ZMNY OPROTI REL. R90: -----------------------------------------------------
1)  funkce GetDescrPtr pejmenovna pro rozlien verz na GetDescrPtr440 (P93)
2)  do funkce OpenLayer doplnn parametr Color (P93)
----------------------------------------------------------------------------- *)

{$LONGSTRINGS OFF}

LIBRARY Emma;

USES DrvTypes, DLL_Util;

TYPE
  ParamIndex_T = (
    NoOfDigits,
    RepeatedCoordinates,
    EvenParityEnabled);

CONST
  ToolCount = 38;
  Both = [UsageDraw, UsageFlash];
  ToolTable: array [1..ToolCount] of ToolDescr_T = (
    (DescrStr: '#0  (Circle 0.10 mm)'; Shape: CircleTool;  Width:  100; Height: 0; Usage: Both; Code:  0),
    (DescrStr: '#1  (Circle 0.15 mm)'; Shape: CircleTool;  Width:  150; Height: 0; Usage: Both; Code:  1),
    (DescrStr: '#2  (Circle 0.20 mm)'; Shape: CircleTool;  Width:  200; Height: 0; Usage: Both; Code:  2),
    (DescrStr: '#3  (Circle 0.25 mm)'; Shape: CircleTool;  Width:  250; Height: 0; Usage: Both; Code:  3),
    (DescrStr: '#4  (Circle 0.30 mm)'; Shape: CircleTool;  Width:  300; Height: 0; Usage: Both; Code:  4),
    (DescrStr: '#5  (Circle 0.40 mm)'; Shape: CircleTool;  Width:  400; Height: 0; Usage: Both; Code:  5),
    (DescrStr: '#6  (Circle 0.50 mm)'; Shape: CircleTool;  Width:  500; Height: 0; Usage: Both; Code:  6),
    (DescrStr: '#7  (Circle 0.60 mm)'; Shape: CircleTool;  Width:  600; Height: 0; Usage: Both; Code:  7),
    (DescrStr: '#8  (Circle 0.70 mm)'; Shape: CircleTool;  Width:  700; Height: 0; Usage: Both; Code:  8),
    (DescrStr: '#9  (Circle 0.80 mm)'; Shape: CircleTool;  Width:  800; Height: 0; Usage: Both; Code:  9),
    (DescrStr: '#10 (Circle 0.90 mm)'; Shape: CircleTool;  Width:  900; Height: 0; Usage: Both; Code: 10),
    (DescrStr: '#11 (Circle 1.0 mm) '; Shape: CircleTool;  Width: 1000; Height: 0; Usage: Both; Code: 11),
    (DescrStr: '#12 (Circle 1.1 mm) '; Shape: CircleTool;  Width: 1100; Height: 0; Usage: Both; Code: 12),
    (DescrStr: '#13 (Circle 1.2 mm) '; Shape: CircleTool;  Width: 1200; Height: 0; Usage: Both; Code: 13),
    (DescrStr: '#14 (Circle 1.3 mm) '; Shape: CircleTool;  Width: 1300; Height: 0; Usage: Both; Code: 14),
    (DescrStr: '#15 (Circle 1.4 mm) '; Shape: CircleTool;  Width: 1400; Height: 0; Usage: Both; Code: 15),
    (DescrStr: '#16 (Circle 1.5 mm) '; Shape: CircleTool;  Width: 1500; Height: 0; Usage: Both; Code: 16),
    (DescrStr: '#17 (Circle 1.6 mm) '; Shape: CircleTool;  Width: 1600; Height: 0; Usage: Both; Code: 17),
    (DescrStr: '#18 (Circle 1.7 mm) '; Shape: CircleTool;  Width: 1700; Height: 0; Usage: Both; Code: 18),
    (DescrStr: '#19 (Circle 1.8 mm) '; Shape: CircleTool;  Width: 1800; Height: 0; Usage: Both; Code: 19),
    (DescrStr: '#20 (Circle 2.0 mm) '; Shape: CircleTool;  Width: 2000; Height: 0; Usage: Both; Code: 20),
    (DescrStr: '#21 (Circle 2.2 mm) '; Shape: CircleTool;  Width: 2200; Height: 0; Usage: Both; Code: 21),
    (DescrStr: '#22 (Circle 2.4 mm) '; Shape: CircleTool;  Width: 2400; Height: 0; Usage: Both; Code: 22),
    (DescrStr: '#23 (Circle 2.6 mm) '; Shape: CircleTool;  Width: 2600; Height: 0; Usage: Both; Code: 23),
    (DescrStr: '#24 (Circle 2.8 mm) '; Shape: CircleTool;  Width: 2800; Height: 0; Usage: Both; Code: 24),
    (DescrStr: '#25 (Circle 3.0 mm) '; Shape: CircleTool;  Width: 3000; Height: 0; Usage: Both; Code: 25),
    (DescrStr: '#26 (Circle 3.2 mm) '; Shape: CircleTool;  Width: 3200; Height: 0; Usage: Both; Code: 26),
    (DescrStr: '#27 (Circle 3.6 mm) '; Shape: CircleTool;  Width: 3600; Height: 0; Usage: Both; Code: 27),
    (DescrStr: '#28 (Circle 4.0 mm) '; Shape: CircleTool;  Width: 4000; Height: 0; Usage: Both; Code: 28),
    (DescrStr: '#29 (Circle 4.5 mm) '; Shape: CircleTool;  Width: 4500; Height: 0; Usage: Both; Code: 29),
    (DescrStr: '#30 (Circle 5.0 mm) '; Shape: CircleTool;  Width: 5000; Height: 0; Usage: Both; Code: 30),
    (DescrStr: '#31 (Square 0.08 mm)'; Shape: SquareTool;  Width:   80; Height: 0; Usage: Both; Code: 31),
    (DescrStr: '#32 (Square 0.10 mm)'; Shape: SquareTool;  Width:  100; Height: 0; Usage: Both; Code: 32),
    (DescrStr: '#33 (Square 0.15 mm)'; Shape: SquareTool;  Width:  150; Height: 0; Usage: Both; Code: 33),
    (DescrStr: '#34 (Square 0.20 mm)'; Shape: SquareTool;  Width:  200; Height: 0; Usage: Both; Code: 34),
    (DescrStr: '#35 (Square 0.30 mm)'; Shape: SquareTool;  Width:  300; Height: 0; Usage: Both; Code: 35),
    (DescrStr: '#36 (Square 0.40 mm)'; Shape: SquareTool;  Width:  400; Height: 0; Usage: Both; Code: 36),
    (DescrStr: '#47 (Target 2.79 mm)'; Shape: SpecialTool; Width: 2790; Height: 0; Usage: Both; Code: 47));

  DriverDescr: DriverDescr_T = (
    Name:         'Emma 4.0 PH 1995';
    MajorVersion: 4;
    MinorVersion: 0;
    Capabilities: [Optimizable, DrawLines, DrawArcs, FlashPads];
    NoOfParams:   Ord (High (ParamIndex_T)) + 1;
    FilesName:    'Emma';
    TargetExt:    '';
    NoOfTools:    ToolCount;
    InitialTools: @ ToolTable [1];
    MaxNoOfTools: MaxToolCount;
    ToolTablePtr: @ WorkToolTable;
    X0:           0;
    Y0:           0;
    X1:           800;
    Y1:           600;
    XDividend:    1000;
    YDividend:    1000;
    Divisor:      1);

  Params: array [ParamIndex_T] of ParamDescr_T = (
   (DescrStr: '>Number of Digits';
    Value:     6;
    ParamType: _Numeric;
    MinVal:    1;
    MaxVal:    8),
   (DescrStr:  '>Repeated Coordinates';
    Value:     Ord (false);
    ParamType: _Explicite;
    Values:    '>Omitted|>Included'),
   (DescrStr:  '>Even Parity';
    Value:     Ord (false);
    ParamType: _Explicite;
    Values:    'Off|On'));

FUNCTION GetDescrPtr440: DescrPtr_T;
begin
  Result := @ DriverDescr;
end;

FUNCTION GetParamPtr (ParamNumber: integer): ParamPtr_T;
begin
  Result := @ Params [ParamIndex_T (ParamNumber)];
end;

PROCEDURE SetParamValue (ParamNumber: integer; ParamValue: integer);
begin
  Params [ParamIndex_T (ParamNumber)].Value := ParamValue;
end;

// -----------------------------------------------------------------------------

CONST CrLf = ^M^J;

VAR
  CurrentX, CurrentY: DriverUnits_T;
  CurrentToolCode:    ToolCode_T;

procedure Output (AsciiString: string);
  var i: integer;
begin
  if Boolean (Params [EvenParityEnabled].Value) then
    for i := 1 to Length (AsciiString) do
      AsciiString [i] := EvenParity (AsciiString [i]);
  WriteStr (AsciiString);
end;

PROCEDURE OpenEquip (WriteProc: WriteProc_T; X0, Y0, X1, Y1: DriverUnits_T);
begin
  Write := WriteProc;
  Output ('%' + CrLf);
  CurrentX := MaxLongInt;
  CurrentY := MaxLongInt;
  CurrentToolCode := MaxInt;
end;

PROCEDURE Comment (const CommentString: string);
begin
  Output ('C ' + CommentString + CrLf);  (* ??? omezit delku? *)
end;

PROCEDURE OpenLayer (Layer: integer; Color: integer = 0);
begin
  Output ('R' + LZIntStr (Layer, 3) + CrLf);
end;

procedure ChangeAperture (ToolNumber: ToolNumber_T);
  var ToolCode: ToolCode_T;
begin
  ToolCode := WorkToolTable [ToolNumber].Code;
  if ToolCode <> CurrentToolCode then
    Output ('I' + LZIntStr (ToolCode, 2) + ' ');
  CurrentToolCode := ToolCode;
end;

procedure OutputCoordinates (X, Y: DriverUnits_T);
begin
  if Boolean (Params [RepeatedCoordinates].Value) or (X <> CurrentX) and (Y <> CurrentY) then
    Output ('X' + LZIntStr (X, Params [NoOfDigits].Value) 
         + ' Y' + LZIntStr (Y, Params [NoOfDigits].Value))
  else if (X = CurrentX) then
    Output ('Y' + LZIntStr (Y, Params [NoOfDigits].Value))
  else
    Output ('X' + LZIntStr (X, Params [NoOfDigits].Value));
  CurrentX := X;
  CurrentY := Y;
end;

procedure MoveToCoordinates (X, Y: DriverUnits_T);
begin
  if (X <> CurrentX) or (Y <> CurrentY) then begin
    Output ('S7 ');
    OutputCoordinates (X, Y);
    Output (CrLf);
  end;
end;

PROCEDURE DrawLine (X0, Y0, X1, Y1: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  ChangeAperture (ToolNumber);
  MoveToCoordinates (X0, Y0);
  Output ('S5 ');
  OutputCoordinates (X1, Y1);
  Output (CrLf);
end;

PROCEDURE DrawArc (X, Y, R: DriverUnits_T; Angle1, Angle2: integer; ToolNumber: ToolNumber_T);
  var Angle: integer;
begin
  ChangeAperture (ToolNumber);
  if Angle1 < Angle2 then begin  {do smeru hodinovych rucicek}
    Angle := Angle1;   Angle1 := Angle2;   Angle2 := Angle;
  end;
  MoveToCoordinates (Round (X + R * Cos (Angle1 * (Pi / 180))),
                     Round (Y + R * Sin (Angle1 * (Pi / 180))));
  Output ('S6 M' + LZIntStr (X, Params [NoOfDigits].Value)
          + ' N' + LZIntStr (Y, Params [NoOfDigits].Value));
  if Angle1 - Angle2 <> 360 then begin
    Output (' ');
    OutputCoordinates (Round (X + R * Cos (Angle2 * (Pi / 180))),
                       Round (Y + R * Sin (Angle2 * (Pi / 180))));
  end;
  Output (CrLf);
end;

PROCEDURE FlashPad (X, Y: DriverUnits_T; ToolNumber: ToolNumber_T);
begin
  ChangeAperture (ToolNumber);
  Output ('S1 ');
  OutputCoordinates (X, Y);
  Output (CrLf);
end;

PROCEDURE CloseEquip;
begin
  Output ('$' + CrLf);
end;

EXPORTS
  GetDescrPtr440,
  GetParamPtr,
  SetParamValue,
  OpenEquip,
  Comment,
  OpenLayer,
  DrawLine,
  DrawArc,
  FlashPad,
  CloseEquip;

BEGIN
END.
